Index: /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 658)
@@ -577,1192 +340,673 @@
      $        no2colx(i)*crscabsi2(13,indexint)
       end do
+
+c     Interpolations
+
       do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
+         auxi = nz2-i+1
+         !O2 tabulated coefficient
+         auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+         !CO2 tabulated coefficient
+         auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+         !O3p tabulated coefficient
+         auxjo3p(i) = jabsifotsintpar(auxi,3,indexint)
+         !N2 tabulated coefficient
+         auxjn2(i) = jabsifotsintpar(auxi,8,indexint)
+         !CO tabulated coefficient
+         auxjco(i) = jabsifotsintpar(auxi,11,indexint)
+         !H tabulated coefficient
+         auxjh(i) = jabsifotsintpar(auxi,12,indexint)
+         !NO2 tabulated coefficient
+         auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
+         !Tabulated column
+         auxcoltab(i) = c1_16(auxi,indexint)
       enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,2,i) = aux1(nlayermx-i+1) 
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
+         do i=1,nz2
+            auxi = nz2-i+1
+            !N tabulated coefficient
+            auxjn(i) = jabsifotsintpar(auxi,9,indexint)
+            !NO tabulated coefficient
+            auxjno(i) = jabsifotsintpar(auxi,10,indexint)
+            !NO2 tabulated coefficient
+            auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
+         enddo
+      endif
+
+      call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         auxi = nlayermx-i+1
+         !O2 interpolated coefficient
+         jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
+     $            wp(i)*auxjo2(ind)
+         !CO2 interpolated coefficient
+         jfotsout(indexint,1,auxi) = wm(i)*auxjco2(ind+1) +
+     $            wp(i)*auxjco2(ind) 
+         !O3p interpolated coefficient
+         jfotsout(indexint,3,auxi) = wm(i)*auxjo3p(ind+1) +
+     $            wp(i)*auxjo3p(ind) 
+         !N2 interpolated coefficient
+         jfotsout(indexint,8,auxi) = wm(i)*auxjn2(ind+1) +
+     $            wp(i)*auxjn2(ind) 
+         !CO interpolated coefficient
+         jfotsout(indexint,11,auxi) = wm(i)*auxjco(ind+1) +
+     $            wp(i)*auxjco(ind)  
+         !H interpolated coefficient
+         jfotsout(indexint,12,auxi) = wm(i)*auxjh(ind+1) +
+     $            wp(i)*auxjh(ind)         
       enddo
-
-
-c**************************************************
-c     co2, 80.6-90.8nm
-c**************************************************
-
-      indexint=16
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $        o2colx(i)*crscabsi2(2,indexint)+
-     $        o3pcolx(i)*crscabsi2(3,indexint)+
-     $        n2colx(i)*crscabsi2(8,indexint)+
-     $        ncolx(i)*crscabsi2(9,indexint)+
-     $        nocolx(i)*crscabsi2(10,indexint)+
-     $        cocolx(i)*crscabsi2(11,indexint)+
-     $        hcolx(i)*crscabsi2(12,indexint)+
-     $        no2colx(i)*crscabsi2(13,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,1,i) = aux1(nlayermx-i+1) 
-      enddo
-
-
-c**************************************************
-c     o3p, 80.6-90.8nm
-c**************************************************
-
-      indexint=16
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $        o2colx(i)*crscabsi2(2,indexint)+
-     $        o3pcolx(i)*crscabsi2(3,indexint)+
-     $        n2colx(i)*crscabsi2(8,indexint)+
-     $        ncolx(i)*crscabsi2(9,indexint)+
-     $        nocolx(i)*crscabsi2(10,indexint)+
-     $        cocolx(i)*crscabsi2(11,indexint)+
-     $        hcolx(i)*crscabsi2(12,indexint)+
-     $        no2colx(i)*crscabsi2(13,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,3,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,3,i) = aux1(nlayermx-i+1) 
-      enddo
-      
-
-c**************************************************
-c     n2, 80.6-90.8nm
-c**************************************************
-
-      indexint=16
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $        o2colx(i)*crscabsi2(2,indexint)+
-     $        o3pcolx(i)*crscabsi2(3,indexint)+
-     $        n2colx(i)*crscabsi2(8,indexint)+
-     $        ncolx(i)*crscabsi2(9,indexint)+
-     $        nocolx(i)*crscabsi2(10,indexint)+
-     $        cocolx(i)*crscabsi2(11,indexint)+
-     $        hcolx(i)*crscabsi2(12,indexint)+
-     $        no2colx(i)*crscabsi2(13,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,8,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,8,i) = aux1(nlayermx-i+1) 
-      enddo
-
-
-c**************************************************
-c     co, 80.6-90.8nm
-c************************************************************
-
-      indexint=16
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $        o2colx(i)*crscabsi2(2,indexint)+
-     $        o3pcolx(i)*crscabsi2(3,indexint)+
-     $        n2colx(i)*crscabsi2(8,indexint)+
-     $        ncolx(i)*crscabsi2(9,indexint)+
-     $        nocolx(i)*crscabsi2(10,indexint)+
-     $        cocolx(i)*crscabsi2(11,indexint)+
-     $        hcolx(i)*crscabsi2(12,indexint)+
-     $        no2colx(i)*crscabsi2(13,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,11,i) = aux1(nlayermx-i+1) 
-      enddo
-
-
-c**************************************************
-c     h, 80.6-90.8nm
-c**************************************************
-
-      indexint=16
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $        o2colx(i)*crscabsi2(2,indexint)+
-     $        o3pcolx(i)*crscabsi2(3,indexint)+
-     $        n2colx(i)*crscabsi2(8,indexint)+
-     $        ncolx(i)*crscabsi2(9,indexint)+
-     $        nocolx(i)*crscabsi2(10,indexint)+
-     $        cocolx(i)*crscabsi2(11,indexint)+
-     $        hcolx(i)*crscabsi2(12,indexint)+
-     $        no2colx(i)*crscabsi2(13,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,12,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,12,i) = aux1(nlayermx-i+1) 
-      enddo
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
+      !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-
-c**************************************************
-c     n, 80.6-90.8nm
-c**************************************************
-
-         indexint=16
          do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
+            ind=auxind(i)
+            auxi = nlayermx-i+1
+            !N interpolated coefficient
+            jfotsout(indexint,9,auxi) = wm(i)*auxjn(ind+1) +
+     $           wp(i)*auxjn(ind) 
+            !NO interpolated coefficient
+            jfotsout(indexint,10,auxi) = wm(i)*auxjno(ind+1) +
+     $           wp(i)*auxjno(ind)
+            !NO2 interpolated coefficient
+            jfotsout(indexint,13,auxi) = wm(i)*auxjno2(ind+1) +
+     $           wp(i)*auxjno2(ind)
+         enddo
+      endif
+c     End interval 16
+
+
+ccccccccccccccccccccccccccccccc
+c     90.9-119.5nm (int 17-24)
+c
+c     Absorption by:
+c     CO2, O2, N2, NO, CO, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input column
+
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
+     $        nocolx(i) + cocolx(i) + no2colx(i)
+      end do
+
+      do indexint=17,24
+
+c     Interpolations
+
          do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,9,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,9,i) = aux1(nlayermx-i+1) 
-         enddo
-
-
-c**************************************************
-c     no, 80.6-90.8nm
-c**************************************************
-
-         indexint=16
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,10,i) = aux1(nlayermx-i+1) 
-         enddo
-
-
-c***********************************************************
-c     no2, 80.6-90.8nm
-c**************************************************
-
-         indexint=16
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,13,i) = aux1(nlayermx-i+1) 
-         enddo
-      
-         endif !Of chemthermod >= 2
-
-c**************************************************
-c      co2, 90.9-119.5nm
-c**************************************************
-
-      limdown=1e-20
-      limup=1e26
-      do indexint=17,24
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
-     $           nocolx(i) + cocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-            aux4(i) = c17_24(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
-            if(indexint.eq.24) then
-          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))*
-     $           (1+alfa(indexint,i)*(t2(i)-t0(i)))
+            auxi = nz2-i+1
+            !CO2 tabulated coefficient
+            auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+            !O2 tabulated coefficient
+            auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+            !N2 tabulated coefficient
+            auxjn2(i) = jabsifotsintpar(auxi,8,indexint)
+            !CO tabulated coefficient
+            auxjco(i) = jabsifotsintpar(auxi,11,indexint)            
+            !Tabulated column
+            auxcoltab(i) = c17_24(auxi)
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
+            do i=1,nz2
+               auxi = nz2-i+1
+               !NO tabulated coefficient
+               auxjno(i) = jabsifotsintpar(auxi,10,indexint)
+               !NO2 tabulated coefficient
+               auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
+            enddo
+         endif
+
+         call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+         !Correction to include T variation of CO2 cross section
+         if(indexint.eq.24) then
+            do i=1,nlayermx
+               auxi = nlayermx-i+1
+               if(sigma(indexint,auxi)*
+     $              alfa(indexint,auxi)*coltemp(auxi)
+     $              .lt.60.) then
+                  cortemp(i)=exp(-sigma(indexint,auxi)*
+     $                alfa(indexint,auxi)*coltemp(auxi))
                else 
-                  jfotsout(indexint,1,i)=0.
-               end if
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c     o2, 90.9-119.5nm
-c**************************************************
-      
-      do indexint=17,24
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
-     $           nocolx(i) + cocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-            aux4(i) = c17_24(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-            if(indexint.eq.24) then
-          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,2,i)=0.
-               end if
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c     n2, 90.9-119.5nm
-c**************************************************
-     
-      do indexint=17,24
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
-     $           nocolx(i) + cocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,8,nz2-i+1)
-            aux4(i) = c17_24(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,8,i) = aux1(nlayermx-i+1)
-            if(indexint.eq.24) then
-          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,8,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,8,i)=0.
-               end if
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c     co, 90.9-119.5nm
-c**************************************************
-     
-      do indexint=17,24
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
-     $           nocolx(i) + cocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
-            aux4(i) = c17_24(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
-            if(indexint.eq.24) then
-          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,11,i)=0.
-               end if
-            end if
-         enddo
-      end do
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-
-c**************************************************
-c     no, 90.9-119.5nm
-c**************************************************
-     
-         do indexint=17,24
-            do i=1,nlayermx
-               aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
-     $              nocolx(i) + cocolx(i) + no2colx(i)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
-               aux4(i) = c17_24(nz2-i+1)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
-               if(indexint.eq.24) then
-                  if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $                 .lt.60.) then
-                     jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
-     $             *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-                  else
-                     jfotsout(indexint,10,i)=0.
-                  end if
+                  cortemp(i)=0.
                end if
             enddo
-         end do
-
-
-c**************************************************
-c     no2, 90.9-119.5nm
-c**************************************************
-     
-         do indexint=17,24
+         else
             do i=1,nlayermx
-               aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
-     $              nocolx(i) + cocolx(i) + no2colx(i)
-            end do
+               cortemp(i)=1.
+            enddo
+         end if
+         do i=1,nlayermx           
+            ind=auxind(i)
+            auxi = nlayermx-i+1
+            !O2 interpolated coefficient
+            jfotsout(indexint,2,auxi) = (wm(i)*auxjo2(ind+1) +
+     $           wp(i)*auxjo2(ind)) * cortemp(i)
+            !CO2 interpolated coefficient
+            jfotsout(indexint,1,auxi) = (wm(i)*auxjco2(ind+1) +
+     $           wp(i)*auxjco2(ind)) * cortemp(i)
+            if(indexint.eq.24) jfotsout(indexint,1,auxi)=
+     $           jfotsout(indexint,1,auxi)*
+     $           (1+alfa(indexint,auxi)*
+     $           (t2(auxi)-t0(auxi)))
+            !N2 interpolated coefficient
+            jfotsout(indexint,8,auxi) = (wm(i)*auxjn2(ind+1) +
+     $            wp(i)*auxjn2(ind)) * cortemp(i)            
+            !CO interpolated coefficient
+            jfotsout(indexint,11,auxi) = (wm(i)*auxjco(ind+1) +
+     $            wp(i)*auxjco(ind)) * cortemp(i)            
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
+            do i=1,nlayermx
+               ind=auxind(i)
+               auxi = nlayermx-i+1
+               !NO interpolated coefficient
+               jfotsout(indexint,10,auxi)=(wm(i)*auxjno(ind+1) +
+     $              wp(i)*auxjno(ind)) * cortemp(i)
+               !NO2 interpolated coefficient
+               jfotsout(indexint,13,auxi)=(wm(i)*auxjno2(ind+1)+
+     $              wp(i)*auxjno2(ind)) * cortemp(i)
+            enddo
+         endif               
+      end do
+c     End intervals 17-24
+
+
+ccccccccccccccccccccccccccccccc
+c     119.6-167.0nm (int 25-29)
+c
+c     Absorption by:
+c     CO2, O2, H2O, H2O2, NO,
+c     CO, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+     $        h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+      end do
+
+      do indexint=25,29
+
+c     Interpolations
+
+         do i=1,nz2
+            auxi = nz2-i+1
+            !CO2 tabulated coefficient
+            auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+            !O2 tabulated coefficient
+            auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+            !H2O tabulated coefficient
+            auxjh2o(i) = jabsifotsintpar(auxi,4,indexint)
+            !H2O2 tabulated coefficient
+            auxjh2o2(i) = jabsifotsintpar(auxi,6,indexint)            
+            !CO tabulated coefficient
+            auxjco(i) = jabsifotsintpar(auxi,11,indexint)            
+            !Tabulated column
+            auxcoltab(i) = c25_29(auxi)
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
             do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-               aux4(i) = c17_24(nz2-i+1)
+               auxi = nz2-i+1
+               !NO tabulated coefficient
+               auxjno(i) = jabsifotsintpar(auxi,10,indexint)
+               !NO2 tabulated coefficient
+               auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
             enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         endif
+         call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayermx
+            ind=auxind(i)
+            auxi = nlayermx-i+1
+            !Correction to include T variation of CO2 cross section
+            if(sigma(indexint,auxi)*alfa(indexint,auxi)*
+     $           coltemp(auxi).lt.60.) then
+               cortemp(i)=exp(-sigma(indexint,auxi)*
+     $              alfa(indexint,auxi)*coltemp(auxi))
+            else 
+               cortemp(i)=0.
+            end if
+            !CO2 interpolated coefficient
+            jfotsout(indexint,1,auxi) = (wm(i)*auxjco2(ind+1) +
+     $           wp(i)*auxjco2(ind)) * cortemp(i) *
+     $           (1+alfa(indexint,auxi)*
+     $           (t2(auxi)-t0(auxi)))
+            !O2 interpolated coefficient
+            jfotsout(indexint,2,auxi) = (wm(i)*auxjo2(ind+1) +
+     $           wp(i)*auxjo2(ind)) * cortemp(i)
+            !H2O interpolated coefficient
+            jfotsout(indexint,4,auxi) = (wm(i)*auxjh2o(ind+1) +
+     $           wp(i)*auxjh2o(ind)) * cortemp(i)
+            !H2O2 interpolated coefficient
+            jfotsout(indexint,6,auxi) = (wm(i)*auxjh2o2(ind+1) +
+     $           wp(i)*auxjh2o2(ind)) * cortemp(i)            
+            !CO interpolated coefficient
+            jfotsout(indexint,11,auxi) = (wm(i)*auxjco(ind+1) +
+     $           wp(i)*auxjco(ind)) * cortemp(i)
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
             do i=1,nlayermx
-               jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-               if(indexint.eq.24) then
-                  if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $                 .lt.60.) then
-                     jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-                  else
-                     jfotsout(indexint,13,i)=0.
-                  end if
-               end if
+               ind=auxind(i)
+               auxi = nlayermx-i+1
+               !NO interpolated coefficient
+               jfotsout(indexint,10,auxi)=(wm(i)*auxjno(ind+1) +
+     $              wp(i)*auxjno(ind)) * cortemp(i)
+               !NO2 interpolated coefficient
+               jfotsout(indexint,13,auxi)=(wm(i)*auxjno2(ind+1)+
+     $              wp(i)*auxjno2(ind)) * cortemp(i)
             enddo
-         end do
-
-         endif !Of chemthermod >= 2
-
-
-c**************************************************
-c      co2, 119.6-167.0nm
-c**************************************************
-
-      do indexint=25,29
+         endif
+
+      end do
+
+c     End intervals 25-29
+
+
+cccccccccccccccccccccccccccccccc
+c     167.1-202.5nm (int 30-31)
+c    
+c     Absorption by:
+c     CO2, O2, H2O, H2O2, NO,
+c     NO2
+cccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+     $        h2o2colx(i) + nocolx(i) + no2colx(i)
+      end do
+
+c     Interpolation
+
+      do indexint=30,31
+
+         do i=1,nz2
+            auxi = nz2-i+1
+            !CO2 tabulated coefficient
+            auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+            !O2 tabulated coefficient
+            auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+            !H2O tabulated coefficient
+            auxjh2o(i) = jabsifotsintpar(auxi,4,indexint)
+            !H2O2 tabulated coefficient
+            auxjh2o2(i) = jabsifotsintpar(auxi,6,indexint)            
+            !Tabulated column
+            auxcoltab(i) = c30_31(auxi)
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
+            do i=1,nz2
+               auxi = nz2-i+1
+               !NO tabulated coefficient
+               auxjno(i) = jabsifotsintpar(auxi,10,indexint)
+               !NO2 tabulated coefficient
+               auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
+            enddo
+         endif
+
+         call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
          do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
-     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-         end do
+            ind=auxind(i)
+            auxi = nlayermx-i+1
+            !Correction to include T variation of CO2 cross section
+            if(sigma(indexint,auxi)*alfa(indexint,auxi)*
+     $           coltemp(auxi).lt.60.) then
+               cortemp(i)=exp(-sigma(indexint,auxi)*
+     $              alfa(indexint,auxi)*coltemp(auxi))
+            else 
+               cortemp(i)=0.
+            end if
+            !CO2 interpolated coefficient
+            jfotsout(indexint,1,auxi) = (wm(i)*auxjco2(ind+1) +
+     $           wp(i)*auxjco2(ind)) * cortemp(i) *
+     $           (1+alfa(indexint,auxi)*
+     $           (t2(auxi)-t0(auxi)))
+            !O2 interpolated coefficient
+            jfotsout(indexint,2,auxi) = (wm(i)*auxjo2(ind+1) +
+     $            wp(i)*auxjo2(ind)) * cortemp(i)
+            !H2O interpolated coefficient
+            jfotsout(indexint,4,auxi) = (wm(i)*auxjh2o(ind+1) +
+     $            wp(i)*auxjh2o(ind)) * cortemp(i)
+            !H2O2 interpolated coefficient
+            jfotsout(indexint,6,auxi) = (wm(i)*auxjh2o2(ind+1) +
+     $            wp(i)*auxjh2o2(ind)) * cortemp(i)            
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
+            do i=1,nlayermx 
+               ind=auxind(i)
+               auxi = nlayermx-i+1
+               !NO interpolated coefficient
+               jfotsout(indexint,10,auxi)=(wm(i)*auxjno(ind+1) +
+     $              wp(i)*auxjno(ind)) * cortemp(i)
+               !NO2 interpolated coefficient
+               jfotsout(indexint,13,auxi)=(wm(i)*auxjno2(ind+1)+
+     $              wp(i)*auxjno2(ind)) * cortemp(i)
+            enddo
+         endif
+
+      end do
+
+c     End intervals 30-31
+
+
+ccccccccccccccccccccccccccccccc
+c     202.6-210.0nm (int 32)
+c
+c     Absorption by:
+c     CO2, O2, H2O2, NO, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      indexint=32
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
+     $        nocolx(i) + no2colx(i)
+      end do
+
+c     Interpolation
+
+      do i=1,nz2
+         auxi = nz2-i+1
+         !CO2 tabulated coefficient
+         auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+         !O2 tabulated coefficient
+         auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+         !H2O2 tabulated coefficient
+         auxjh2o2(i) = jabsifotsintpar(auxi,6,indexint)         
+         !Tabulated column
+         auxcoltab(i) = c32(auxi)
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-            aux4(i) = c25_29(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            auxi = nz2-i+1
+            !NO tabulated coefficient
+            auxjno(i) = jabsifotsintpar(auxi,10,indexint)
+            !NO2 tabulated coefficient
+            auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
+         enddo
+      endif
+      call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         auxi = nlayermx-i+1
+         !Correction to include T variation of CO2 cross section
+         if(sigma(indexint,nlayermx-i+1)*alfa(indexint,auxi)*
+     $        coltemp(auxi).lt.60.) then
+            cortemp(i)=exp(-sigma(indexint,auxi)*
+     $           alfa(indexint,auxi)*coltemp(auxi))
+         else 
+            cortemp(i)=0.
+         end if
+         !CO2 interpolated coefficient
+         jfotsout(indexint,1,auxi) = (wm(i)*auxjco2(ind+1) +
+     $        wp(i)*auxjco2(ind)) * cortemp(i) *
+     $        (1+alfa(indexint,auxi)*
+     $        (t2(auxi)-t0(auxi)))
+         !O2 interpolated coefficient
+         jfotsout(indexint,2,auxi) = (wm(i)*auxjo2(ind+1) +
+     $        wp(i)*auxjo2(ind)) * cortemp(i)
+         !H2O2 interpolated coefficient
+         jfotsout(indexint,6,auxi) = (wm(i)*auxjh2o2(ind+1) +
+     $        wp(i)*auxjh2o2(ind)) * cortemp(i)         
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nlayermx
-          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-     $           *(1+alfa(indexint,i)*(t2(i)-t0(i)))               
-            else
-               jfotsout(indexint,1,i) = 0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      o2, 119.6-167.0nm
-c**************************************************
-
-      do indexint=25,29
+            auxi = nlayermx-i+1
+            ind=auxind(i)
+            !NO interpolated coefficient
+            jfotsout(indexint,10,auxi) = (wm(i)*auxjno(ind+1) +
+     $           wp(i)*auxjno(ind)) * cortemp(i)
+           !NO2 interpolated coefficient
+            jfotsout(indexint,13,auxi) = (wm(i)*auxjno2(ind+1) +
+     $           wp(i)*auxjno2(ind)) * cortemp(i)
+         enddo
+      endif
+
+c     End of interval 32
+
+
+ccccccccccccccccccccccccccccccc
+c     210.1-231.0nm (int 33)
+c     
+c     Absorption by:
+c     O2, H2O2, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      indexint=33
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
+      end do
+
+c     Interpolation
+
+      do i=1,nz2
+         auxi = nz2-i+1
+         !O2 tabulated coefficient
+         auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+         !H2O2 tabulated coefficient
+         auxjh2o2(i) = jabsifotsintpar(auxi,6,indexint)
+         !Tabulated column
+         auxcoltab(i) = c33(auxi)
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
+         do i=1,nz2
+            !NO2 tabulated coefficient
+            auxjno2(i) = jabsifotsintpar(nz2-i+1,13,indexint)
+         enddo
+      endif
+      call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         auxi = nlayermx-i+1
+         !O2 interpolated coefficient
+         jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
+     $        wp(i)*auxjo2(ind)
+         !H2O2 interpolated coefficient
+         jfotsout(indexint,6,auxi) = wm(i)*auxjh2o2(ind+1) +
+     $        wp(i)*auxjh2o2(ind)         
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-         end do
+            ind=auxind(i)
+            !NO2 interpolated coefficient
+            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+     $           wp(i)*auxjno2(ind)
+         enddo
+      endif
+
+c     End of interval 33
+
+
+ccccccccccccccccccccccccccccccc
+c     231.1-240.0nm (int 34)
+c
+c     Absorption by:
+c     O2, H2O2, O3, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      indexint=34
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+     $        no2colx(i)
+      end do
+
+c     Interpolation
+
+      do i=1,nz2
+         auxi = nz2-i+1
+         !O2 tabulated coefficient
+         auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+         !H2O2 tabulated coefficient
+         auxjh2o2(i) = jabsifotsintpar(auxi,6,indexint)
+         !O3 tabulated coefficient
+         auxjo3(i) = jabsifotsintpar(auxi,7,indexint)         
+         !Tabulated column
+         auxcoltab(i) = c34(nz2-i+1)
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-            aux4(i) = c25_29(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            !NO2 tabulated coefficient
+            auxjno2(i) = jabsifotsintpar(nz2-i+1,13,indexint)
+         enddo
+      endif
+      call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         auxi = nlayermx-i+1
+         !O2 interpolated coefficient
+         jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
+     $        wp(i)*auxjo2(ind)
+         !H2O2 interpolated coefficient
+         jfotsout(indexint,6,auxi) = wm(i)*auxjh2o2(ind+1) +
+     $        wp(i)*auxjh2o2(ind)
+         !O3 interpolated coefficient
+         jfotsout(indexint,7,auxi) = wm(i)*auxjo3(ind+1) +
+     $        wp(i)*auxjo3(ind)         
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,2,i)=0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      h2o, 119.6-167.0nm
-c**************************************************
-
-      do indexint=25,29
+            ind=auxind(i)
+            !NO2 interpolated coefficient
+            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+     $           wp(i)*auxjno2(ind)
+         enddo
+      endif
+
+c     End of interval 34      
+
+
+ccccccccccccccccccccccccccccccc
+c     240.1-337.7nm (int 35)
+c
+c     Absorption by:
+c     H2O2, O3, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      indexint=35
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+      end do
+
+c     Interpolation
+
+      do i=1,nz2
+         auxi = nz2-i+1
+         !H2O2 tabulated coefficient
+         auxjh2o2(i) = jabsifotsintpar(auxi,6,indexint)
+         !O3 tabulated coefficient
+         auxjo3(i) = jabsifotsintpar(auxi,7,indexint)
+         !Tabulated column
+         auxcoltab(i) = c35(auxi)
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
+         do i=1,nz2
+            !NO2 tabulated coefficient
+            auxjno2(i) = jabsifotsintpar(nz2-i+1,13,indexint)
+         enddo
+      endif
+      call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         auxi = nlayermx-i+1
+         !H2O2 interpolated coefficient
+         jfotsout(indexint,6,auxi) = wm(i)*auxjh2o2(ind+1) +
+     $        wp(i)*auxjh2o2(ind)
+         !O3 interpolated coefficient
+         jfotsout(indexint,7,auxi) = wm(i)*auxjo3(ind+1) +
+     $        wp(i)*auxjo3(ind)         
+      enddo
+      if(chemthermod.ge.2) then
          do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-         end do
+            ind=auxind(i)
+            !NO2 interpolated coefficient
+            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+     $           wp(i)*auxjno2(ind)
+         enddo
+      endif
+
+c     End of interval 35
+
+ccccccccccccccccccccccccccccccc
+c     337.8-800.0 nm (int 36)
+c     
+c     Absorption by:
+c     O3, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+
+      indexint=36
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = o3colx(i) + no2colx(i)
+      end do
+
+c     Interpolation
+
+      do i=1,nz2
+         auxi = nz2-i+1
+         !O3 tabulated coefficient
+         auxjo3(i) = jabsifotsintpar(auxi,7,indexint)         
+         !Tabulated column
+         auxcoltab(i) = c36(auxi)
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,4,nz2-i+1)
-            aux4(i) = c25_29(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            !NO2 tabulated coefficient
+            auxjno2(i) = jabsifotsintpar(nz2-i+1,13,indexint)
+         enddo
+      endif
+      call interfast
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         !O3 interpolated coefficient
+         jfotsout(indexint,7,nlayermx-i+1) = wm(i)*auxjo3(ind+1) +
+     $        wp(i)*auxjo3(ind)         
+      enddo
+      !Only if chemthermod.ge.2
+      if(chemthermod.ge.2) then
          do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,4,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,4,i) = 0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      h2o2,119.6-167.0nm
-c**************************************************
-
-      do indexint=25,29
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
-            aux4(i) = c25_29(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,6,i) = 0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      co, 119.6-167.0nm
-c**************************************************
-
-      do indexint=25,29
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
-            aux4(i) = c25_29(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,11,i) = 0.
-            end if
-         enddo
-      end do
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-
-c**************************************************
-c      no, 119.6-167.0nm
-c**************************************************
-
-         do indexint=25,29
-            do i=1,nlayermx
-               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $              h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
-               aux4(i) = c25_29(nz2-i+1)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $              .lt.60.) then
-                  jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
-     $             *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,10,i) = 0.
-               end if
-            enddo
-         end do
-
-
-c**************************************************
-c      no2, 119.6-167.0nm
-c**************************************************
-
-         do indexint=25,29
-            do i=1,nlayermx
-               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $              h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-               aux4(i) = c25_29(nz2-i+1)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $              .lt.60.) then
-                  jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-     $             *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,13,i) = 0.
-               end if
-            enddo
-         end do
-
-         endif !Of chemthermod >= 2
-
-
-c**************************************************
-c      co2, 167.0-202.5nm
-c**************************************************
-
-      do indexint=30,31
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
-     $           h2o2colx(i) + nocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-            aux4(i) = c30_31(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-     $           *(1+alfa(indexint,i)*(t2(i)-t0(i)))               
-            else
-               jfotsout(indexint,1,i) = 0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      o2, 167.0-202.5nm
-c**************************************************
-
-      do indexint=30,31
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-            aux4(i) = c30_31(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,2,i)=0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      h2o, 167.0-202.5nm
-c**************************************************
-
-      do indexint=30,31
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,4,nz2-i+1)
-            aux4(i) = c30_31(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,4,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,4,i) = 0.
-            end if
-         enddo
-      end do
-
-
-c**************************************************
-c      h2o2, 167.0-202.5nm
-c**************************************************
-
-      do indexint=30,31
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $           h2o2colx(i) + nocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
-            aux4(i) = c30_31(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,6,i) = 0.
-            end if
-         enddo
-      end do
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-      
-c**************************************************
-c      no, 167.0-202.5nm
-c**************************************************
-
-         do indexint=30,31
-            do i=1,nlayermx
-               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $              h2o2colx(i) + nocolx(i) + no2colx(i)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
-               aux4(i) = c30_31(nz2-i+1)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $              .lt.60.) then
-                  jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
-     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,10,i) = 0.
-               end if
-            enddo
-         end do
-
-
-c**************************************************
-c      no2, 167.0-202.5nm
-c**************************************************
-
-         do indexint=30,31
-            do i=1,nlayermx
-               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
-     $              h2o2colx(i) + nocolx(i) + no2colx(i)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-               aux4(i) = c30_31(nz2-i+1)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $              .lt.60.) then
-                  jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-               else
-                  jfotsout(indexint,13,i) = 0.
-               end if
-            enddo
-         end do
-         
-      endif !Of chemthermod >= 2
-
-c**************************************************
-c     co2, 202.6-210.0nm
-c**************************************************
-
-      indexint=32
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
-     $        nocolx(i) + no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-         aux4(i) = c32(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
-     $           *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-     $           *(1+alfa(indexint,i)*(t2(i)-t0(i)))
-         else
-            jfotsout(indexint,1,i)=0.
-         end if
-      enddo
-
-
-c**************************************************
-c     o2, 202.6-210.0nm
-c**************************************************
-
-      indexint=32
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
-     $        nocolx(i) + no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-         aux4(i) = c32(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-     $           *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-         else
-            jfotsout(indexint,2,i)=0.
-         end if
-      enddo
-
-
-c**************************************************
-c     h2o2, 202.6-210.0nm
-c**************************************************
-
-      indexint=32
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
-     $        nocolx(i) + no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
-         aux4(i) = c32(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
-     $           *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-         else
-            jfotsout(indexint,6,i)=0.
-         end if
-      enddo
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.eq.2) then
-
-c**************************************************
-c     no, 202.6-210.0nm
-c**************************************************
-
-         indexint=32
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
-     $           nocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
-            aux4(i) = c32(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $           .lt.60.) then
-               jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
-     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,10,i)=0.
-            end if
-         enddo
-
-
-c**************************************************
-c     no2, 202.6-210.0nm
-c**************************************************
-
-         indexint=32
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
-     $           nocolx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-            aux4(i) = c32(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
-     $           .lt.60.) then
-               jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
-            else
-               jfotsout(indexint,13,i)=0.
-            end if
-         enddo
-         
-      endif !Of chemthermod >= 2
-
-
-c**************************************************
-c     o2, 210.0-231.0nm
-c**************************************************
-
-      indexint=33
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-         aux4(i) = c33(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-      enddo
-
-
-c**************************************************
-c     h2o2, 210.1-231.0nm
-c**************************************************
-
-      indexint=33
-      limdown=1.e-20
-      limup=1e25
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
-         aux4(i) = c33(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
-      enddo
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-
-c**************************************************
-c     no2, 210.1-231.0nm
-c**************************************************
-
-         indexint=33
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-            aux4(i) = c33(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif !Of chemthermod >= 2
-
-
-c**************************************************
-c     o2, 231.-240.nm
-c**************************************************
-
-      indexint=34
-      limdown=1.e-20
-      limup=1e25
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
-     $        no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-         aux4(i) = c34(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-      enddo
-
-
-c**************************************************
-c     h2o2, 231.0-240.nm
-c**************************************************
-
-      indexint=34
-      limdown=1.e-20
-      limup=1e25
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
-     $        no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
-         aux4(i) = c34(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
-      enddo
-
-
-      !Only if Ozone, Nitrogen or ionospheric chem. requested
-      if(chemthermod.ge.1) then
-
-c**************************************************
-c     o3, 231.0-240.nm
-c**************************************************
-
-         indexint=34
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
-     $           no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,7,nz2-i+1)
-            aux4(i) = c34(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,7,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif !Of chemthermod.ge.1
-
-
-      !Only if nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-
-c**************************************************
-c     no2, 231.0-240.nm
-c**************************************************
-
-         indexint=34
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
-     $           no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-            aux4(i) = c34(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif !Of chemthermod >= 2
-
-
-c**************************************************
-c     h2o2, 240.0-337.7nm
-c**************************************************
-
-      indexint=35
-      limdown=1.e-20
-      limup=1e25
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
-         aux4(i) = c35(nz2-i+1)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
-      enddo
-      
-
-      !Only if Ozone, Nitrogen or ionospheric chem. requested
-      if(chemthermod.ge.1) then
-
-c**************************************************
-c     o3, 240.0-337.7nm
-c**************************************************
-
-         indexint=35
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,7,nz2-i+1)
-            aux4(i) = c35(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,7,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif !Of chemthermod.ge.1
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-
-c**************************************************
-c     no2, 240.0-337.7nm
-c**************************************************
-
-         indexint=35
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-            aux4(i) = c35(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif !Of chemthermod.ge.2
-
-
-      !Only if Ozone, Nitrogen or ionospheric chem. requested
-      if(chemthermod.ge.1) then
-
-c**************************************************
-c     o3, 337.7-800.0nm
-c**************************************************
-
-         indexint=36
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = o3colx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,7,nz2-i+1)
-            aux4(i) = c36(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,7,i) = aux1(nlayermx-i+1)
-         enddo
-
+            ind=auxind(i)
+            !NO2 interpolated coefficient
+            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+     $           wp(i)*auxjno2(ind)
+         enddo
       endif
 
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-
-c**************************************************
-c     no2, 337.7-800.0nm
-c**************************************************
-
-         indexint=36
-         limdown=1.e-20
-         limup=1e25
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = o3colx(i) + no2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-            aux4(i) = c36(nz2-i+1)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif !Of chemthermod.ge.2
+c     End of interval 36
+
+c     End of interpolation to obtain photoabsorption rates
+
+
       return
 
